<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AffiliateSite StructType
 * @subpackage Structs
 */
class AffiliateSite extends AbstractStructBase
{
    /**
     * The ID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * @var int
     */
    public $ID;
    /**
     * The name
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * @var string
     */
    public $name;
    /**
     * The URL
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * @var string
     */
    public $URL;
    /**
     * The info
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var \StructType\AffiliateSiteInfo
     */
    public $info;
    /**
     * Constructor method for AffiliateSite
     * @uses AffiliateSite::setID()
     * @uses AffiliateSite::setName()
     * @uses AffiliateSite::setURL()
     * @uses AffiliateSite::setInfo()
     * @param int $iD
     * @param string $name
     * @param string $uRL
     * @param \StructType\AffiliateSiteInfo $info
     */
    public function __construct($iD = null, $name = null, $uRL = null, \StructType\AffiliateSiteInfo $info = null)
    {
        $this
            ->setID($iD)
            ->setName($name)
            ->setURL($uRL)
            ->setInfo($info);
    }
    /**
     * Get ID value
     * @return int|null
     */
    public function getID()
    {
        return $this->ID;
    }
    /**
     * Set ID value
     * @param int $iD
     * @return \StructType\AffiliateSite
     */
    public function setID($iD = null)
    {
        // validation for constraint: int
        if (!is_null($iD) && !is_numeric($iD)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($iD)), __LINE__);
        }
        $this->ID = $iD;
        return $this;
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \StructType\AffiliateSite
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get URL value
     * @return string|null
     */
    public function getURL()
    {
        return $this->URL;
    }
    /**
     * Set URL value
     * @param string $uRL
     * @return \StructType\AffiliateSite
     */
    public function setURL($uRL = null)
    {
        // validation for constraint: string
        if (!is_null($uRL) && !is_string($uRL)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($uRL)), __LINE__);
        }
        $this->URL = $uRL;
        return $this;
    }
    /**
     * Get info value
     * @return \StructType\AffiliateSiteInfo|null
     */
    public function getInfo()
    {
        return $this->info;
    }
    /**
     * Set info value
     * @param \StructType\AffiliateSiteInfo $info
     * @return \StructType\AffiliateSite
     */
    public function setInfo(\StructType\AffiliateSiteInfo $info = null)
    {
        $this->info = $info;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AffiliateSite
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
